
#include "../stdafx.h"
#include "IniFile.h"

CIniFile::CIniFile(void)
{
	_m_strFileName = _T("");
	_m_nMode = 0;
	_m_ulState = 0;
}

CIniFile::~CIniFile(void)
{
}

bool CIniFile::Open(LPCTSTR pstrFileName, int nMode)
{
	CFile l_file;
	if(!l_file.Open(pstrFileName, nMode))
	{
		return FALSE;
	}

	_m_strFileName = l_file.GetFilePath();
	l_file.Close();

	_m_nMode = nMode;
	_m_ulState |= STATE_OPEN;

	return TRUE;
}

void CIniFile::Close(void)
{
	_m_strFileName = _T("");
	_m_nMode = 0;
	_m_ulState = 0;
}

LPCTSTR CIniFile::GetFileName(void)
{
	return _m_strFileName;
}

bool CIniFile::WriteInteger(int nSrc, LPCTSTR pstrAppName, LPCTSTR pstrKeyName)
{
	if(!IsOpen())
	{
		return FALSE;
	}

	TCHAR l_tcWrite[80];
	_itow(nSrc, l_tcWrite,  10);

	return WritePrivateProfileString(pstrAppName, pstrKeyName, l_tcWrite, _m_strFileName);
}

bool CIniFile::WriteString(LPCTSTR pstrSrc, LPCTSTR pstrAppName, LPCTSTR pstrKeyName)
{
	if(!IsOpen())
	{
		return FALSE;
	}

	return WritePrivateProfileString(pstrAppName, pstrKeyName, pstrSrc, _m_strFileName);
}

int CIniFile::ReadInteger(LPCTSTR pstrAppName, LPCTSTR pstrKeyName, int nDefault /*= 0*/)
{
	if(!IsOpen())
	{
		return FALSE;
	}

	TCHAR l_tcRead[80];
	TCHAR l_tcDefault[80];
	_itow(nDefault, l_tcDefault,  10);

	GetPrivateProfileString(pstrAppName, pstrKeyName, l_tcDefault, l_tcRead, 80, _m_strFileName);

	return _wtoi(l_tcRead);
}

CString CIniFile::ReadString(LPCTSTR pstrAppName, LPCTSTR pstrKeyName, const CString& strDefault /*= _T("")*/)
{
	if(!IsOpen())
	{
		return FALSE;
	}

	TCHAR l_tcRead[DEFAULT_STRING_LEN];
	CString l_strRet;
	GetPrivateProfileString(pstrAppName, pstrKeyName, strDefault, l_tcRead, DEFAULT_STRING_LEN, _m_strFileName);
	l_strRet = l_tcRead;

	return l_strRet;
}

bool CIniFile::IsOpen(void)
{
	if(_m_ulState & STATE_OPEN)
	{
		return TRUE;
	}

	return FALSE;
}