#pragma once
#include "afx.h"

#include "../XLib/XGlobal.h"

class CIniFile
{
public:
	typedef enum
	{
		STATE_OPEN = 0x00000001
	}EState;

	typedef enum
	{
		DEFAULT_STRING_LEN		=	1024,
	}EDefault;

public:
	CIniFile(void);
	~CIniFile(void);

	bool	Open(LPCTSTR pstrFileName, int nMode);
	void	Close(void);

	LPCTSTR	GetFileName(void);

	bool	IsOpen(void);

	int		ReadInteger(LPCTSTR pstrAppName, LPCTSTR pstrKeyName, int nDefault = 0);
	CString	ReadString(LPCTSTR pstrAppName, LPCTSTR pstrKeyName, const CString& strDefault = _T(""));

	bool	WriteInteger(int nSrc, LPCTSTR pstrAppName, LPCTSTR pstrKeyName);
	bool	WriteString(LPCTSTR pstrSrc, LPCTSTR pstrAppName, LPCTSTR pstrKeyName);

protected:
	CString	_m_strFileName;
	int		_m_nMode;
	ulong	_m_ulState;
};
