/************************************************************************/
/* ôҪu-bootֲġ                                     */
/************************************************************************/
#include <string.h>
#include <stdio.h>
#include "cmd.h"
#include "config.h"

extern cmd_tbl_s __user_cmd_start;
extern cmd_tbl_s __user_cmd_end;

static int __do_help (cmd_tbl_s *cmd_start, int cmd_items, cmd_tbl_s * cmdtp, int
			  flag, int argc, char * const argv[])
{
	int i;
	int rcode = 0;

	if (argc == 1)
	{	
		/*show list of commands */
		cmd_tbl_s* cmd_array[cmd_items];
		int i, j, swaps;

		/* Make array of commands from .uboot_cmd section */
		cmdtp = cmd_start;
		for (i = 0; i < cmd_items; i++)
		{
			cmd_array[i] = cmdtp++;
		}

		/* Sort command list (trivial bubble sort) */
		for (i = cmd_items - 1; i > 0; i--)
		{
			swaps = 0;
			for (j = 0; j < i; j++)
			{
				if (strcmp (cmd_array[j]->name,
					cmd_array[j + 1]->name) > 0)
				{
					cmd_tbl_s *tmp;
					tmp = cmd_array[j];
					cmd_array[j] = cmd_array[j + 1];
					cmd_array[j + 1] = tmp;
					++swaps;
				}
			}
			if (!swaps)
			{
				break;
			}
		}

		/* print short help (usage) */
		for (i = 0; i < cmd_items; i++)
		{
			const char *usage = cmd_array[i]->usage;

			if (usage == NULL)
			{
				continue;
			}
			printf("%-*s- %s\n", CONFIG_USER_CMD_HELP_WIDTH, cmd_array[i]->name, usage);
		}
		return 0;
	}
	/*
	* command help (long version)
	*/
	for (i = 1; i < argc; i++)
	{
		if ((cmdtp = cmd_find_from_table(argv[i], cmd_start, cmd_items )) != NULL)
		{
			rcode |= cmd_print_usage(cmdtp);
		} 
		else
		{
			printf ("Unknown command '%s' - try 'help'"
				" without arguments for list of all"
				" known commands\n\n", argv[i]
			);
			rcode = 1;
		}
	}

	return rcode;
}

static int cmd_do_help(cmd_tbl_s * cmdtp, int flag, int argc, char * const argv[])
{
	return __do_help(&__user_cmd_start, &__user_cmd_end - &__user_cmd_start, 
		cmdtp, flag, argc, argv);
}

USER_CMD(
		help, CONFIG_USER_CMD_MAX_ARG_CNT, 1, cmd_do_help,
		"print command description/usage",
		"\n"
		"	- print brief description of all commands\n"
		"help command ...\n"
		"	- print detailed usage of 'command'"
		);

/* This does not use the U_BOOT_CMD macro as ? can't be used in symbol names */
cmd_tbl_s __user_cmd_question_mark Struct_Section = 
{
	"?",	CONFIG_USER_CMD_MAX_ARG_CNT,	1,	cmd_do_help,
	"alias for 'help'",
	""
};