#include <string.h>
#include "menu.h"

void menu_init(menu_s* menu)
{
	memset(menu, 0, sizeof(menu_s));
}

int	menu_add_item(menu_s* menu, menu_s* item, menu_head_s* head)
{
	int index = menu->__item_cnt;

	item->parent = menu;
	item->index = menu->__item_cnt;
	menu->__item_cnt++;

	list_add_tail(&item->__list, head);

	return index;
}

int	menu_add_item_arr(menu_s* menu, menu_s* item_arr, int item_cnt)
{
	menu->__item_arr = item_arr;
	menu->__item_cnt = item_cnt;

	return item_cnt;
}

menu_s* menu_get_item(menu_s* menu, int index, menu_head_s* head)
{
	int i;
	menu_head_s* pos;
	menu_s* item;

	if(index >= menu->__item_cnt)
	{
		return NULL;
	}

	if(menu->__item_arr)
	{
		for(i = 0; i < menu->__item_cnt; i++)
		{
			if(menu->__item_arr[i].index == index)
			{
				return menu->__item_arr + i;
			}
		}

		return NULL;
	}

	list_for_each(pos, head)
	{
		item = list_entry(pos, menu_s, __list);
		if(item->parent == menu && item->index == index)
		{
			return item;
		}
	}

	return NULL;
}

menu_s* menu_get_item_arr(menu_s* menu, menu_s** item_arr, int* item_cnt)
{
	*item_arr = menu->__item_arr;
	*item_cnt = menu->__item_cnt;

	return menu->__item_arr;
}

int menu_get_item_count(menu_s* menu)
{
	return menu->__item_cnt;
}