/*************************************************
* FILE         : XDef.h
* VERSION      : 10.03.29
* AUTHOR       : XuanLin
* DATE - TIME  : 2010.03.29

* QQ           : 253892573
* MAIL         : 253892573@qq.com

A cross-platform standard define.
**************************************************/

#ifndef XDEF_H
#define XDEF_H

#if defined X_CPU_STM32F10X
#ifndef NULL
#define NULL    0
#endif

//////////ͨñƽ̨///////
#else
#ifndef TRUE
#define TRUE    1
#endif

#ifndef FALSE
#define FALSE   0
#endif

#ifndef NULL
#define NULL    0
#endif

#endif

#define YES				1
#define NO				0
#define PASS			1
#define FAIL			0

#define PUBLIC
#define PRIVATE			//Means just the object can use it, others can't use.
#define PROTECTED

typedef enum
{
    X_DIR_UP			= 0x1,
    X_DIR_DOWN			= 0x2,
    X_DIR_LEFT			= 0x4,
    X_DIR_RIGHT			= 0x8,
    X_DIR_LEFT_UP       = X_DIR_LEFT | X_DIR_UP,
    X_DIR_LEFT_DOWN     = X_DIR_LEFT | X_DIR_DOWN,
    X_DIR_RIGHT_UP      = X_DIR_RIGHT | X_DIR_UP,
    X_DIR_RIGHT_DOWN    = X_DIR_RIGHT | X_DIR_DOWN
}X_ENUM_DIR;

typedef enum
{
    X_DIR_INNER_TOP				= 0x1,
    X_DIR_INNER_BOTTOM			= 0x2,
    X_DIR_INNER_LEFT			= 0x4,
    X_DIR_INNER_RIGHT			= 0x8,
    X_DIR_INNER_LEFT_TOP        = X_DIR_INNER_LEFT | X_DIR_INNER_TOP,
    X_DIR_INNER_LEFT_BOTTOM     = X_DIR_INNER_LEFT | X_DIR_INNER_BOTTOM,
    X_DIR_INNER_RIGHT_UP        = X_DIR_INNER_RIGHT | X_DIR_INNER_TOP,
    X_DIR_INNER_RIGHT_BOTTOM    = X_DIR_INNER_RIGHT | X_DIR_INNER_BOTTOM
}X_ENUM_INNER_DIR;      //Inner direction of the thing

typedef enum
{
    X_FIX_NONE						= 0x1,
    X_FIX_ABSLT_FIXED				= 0x2,
    X_FIX_RELAT_FIXED				= 0x4,
}X_EMUM_FIX_MODE;

typedef enum
{
    X_ASPECT_RATIO_IGNORE           = 0x1,
    X_ASPECT_RATIO_KEEP             = 0x2,
    X_ASPECT_RATIO_KEEP_BY_EXPAND   = 0x4
}X_EMUM_ASPECT_RATIO_MODE;

typedef enum
{
	X_TYPE_EVENT_READ				= 0x1,
	X_TYPE_EVENT_WRITE_END			= 0x2,
	X_TYPE_EVENT_TIMEOUT			= 0x4
}X_ENUM_EVENT_TYPE;

typedef enum
{
	X_RADIX_2						= 2,
	X_RADIX_8						= 8,
	X_RADIX_10						= 10,
	X_RADIX_16						= 16
}X_ENUM_RADIX;

#endif // XDEF_H
