
/*************************************************
* FILE         : XType.h
* VERSION      : 10.03.29
* AUTHOR       : XuanLin
* DATE - TIME  : 2010.03.29

* QQ           : 253892573
* MAIL         : 253892573@qq.com

A cross-platform standard define.
**************************************************/

#ifndef XTYPE_H
#define XTYPE_H
#include "def.h"

typedef unsigned char           uchar;
typedef unsigned int            uint;
typedef unsigned long           ulong;
typedef unsigned short          ushort;
typedef unsigned long long int  u64;
typedef long long int           s64;
typedef unsigned int            u32;
typedef int                     s32;
typedef unsigned short          u16;
typedef short                   s16;
typedef unsigned char           u8;
typedef char                   	s8;
#if defined X_LIB_CURSES
#include <curses.h>
#else
typedef uchar                   bool;
#endif

typedef void*					lparam_t;
typedef void*					wparam_t;
typedef int (*onevent_calbk_f)(void* obj, lparam_t lparam, wparam_t wparam);
typedef struct  
{
	void*	obj;
	void*	med;
}calbk_s;

typedef struct
{
	int 	x;
	int 	y;
}point_s;

typedef point_s		pos_s;

typedef struct
{
	int		left;
	int		up;
	int		right;
	int		down;
}rect_s;

#endif // XTYPE_H
