#ifndef TEST_FUNC_H
#define TEST_FUNC_H
#include "../global.h"
#include "../core/menu.h"

#define	TEST_INVALID_INDEX		-1

//
enum
{
	TEST_TYPE_ITEM_FUNC			= 0,
	TEST_TYPE_ITEM_MISC			= 1,
	TEST_TYPE_ITEM_MODULE		= 2,
	TEST_TYPE_ITEM_FILE			= 3,
	TEST_TYPE_ITEM_LIB			= 4,

	TEST_TYPE_ITEM_TOP			= TEST_TYPE_ITEM_LIB,
};

//ģʽ
enum
{
	TEST_MODE_TEST_INVALID		= -1,
	TEST_MODE_TEST_AUTO			= 0,					//Զ
	TEST_MODE_TEST_USER			= 1,					//û
	TEST_MODE_TEST_DEFAULT		= TEST_MODE_TEST_USER,
};

//ԵԪ
enum
{
	TEST_UNIT_INVALID			= -1,
	TEST_UNIT_FUNC				= 0,					//ӡ
	TEST_UNIT_MODULE			= 1,
	TEST_UNIT_FILE				= 2,
	TEST_UNIT_LIB				= 3,
	TEST_UNIT_DEFAULT			= TEST_UNIT_FUNC,
};

typedef struct test_item	test_item_s;
typedef menu_do_f			test_do_f;
typedef void (*test_init_f)(test_item_s* parent);

struct test_item
{
	char					name[100];
	int						type;
	menu_s					menu;
	test_item_s*			parent;
};

int				test_add_sub_item(test_item_s* item, test_item_s* sub_item_arr,				//
								  int sub_item_cnt);
int				test_do_nothing(void* arg);													//
test_item_s*	test_find_item(int index);													//Ѱ
void			test_get_sub_item(test_item_s* item, test_item_s** sub_item_arr,			//
								  int* sub_item_cnt);
int				test_get_test_mode(void);													//òģʽ
test_item_s*	test_get_top_item(void);													//ö
char*			test_get_type_name(char* name, int type);									//ͨͻ
int				test_get_unit(void);														//СõԪ
int				test_get_user_answer(void);													//ûĴ
void			test_init_file(test_item_s* item, const char* name, test_do_f test,			//ʼļ͵
							   const char* menu_name, test_item_s* parent_item);
void			test_init_func(test_item_s* item, const char* name, test_do_f func,			//ʼ͵
							   const char* menu_name, test_item_s* parent_item);
void			test_init_item(test_item_s* item, const char* name, test_do_f test,			//ʼ
							   int type, const char* menu_name, test_item_s* parent_item);	
void			test_init_lib(test_item_s* item, const char* name, test_do_f test,			//ʼ͵
							  const char* menu_name, test_item_s* parent_item);
void			test_init_misc(test_item_s* item, const char* name, test_do_f test,			//ʼ͵
							   const char* menu_name, test_item_s* parent_item);
void			test_init_module(test_item_s* item, const char* name, test_do_f test,		//ʼģ͵
								 const char* menu_name, test_item_s* parent_item);			
bool			test_is_in_unit(const test_item_s* item, int unit);							//ǷڸõԪӼ
bool			test_is_invalid_type(int type);
void			test_menu_up(void);															//һ˵
void			test_print_ask_check(const char* format, ...);								//ӡѯУϢ
void			test_print_ask_test(const char* name, int type);							//ӡѯʲϢ
void			test_print_err(const char* name, const char* format, ...);					//ӡϢ
void			test_print_fail(const char* name, int type);								//ӡʧϢ
void			test_print_pass(const char* name, int type);								//ӡͨϢ
int				test_run_item(test_item_s* item);											//вԸ
int 			test_sel_item(int index);													//ѡĳڸõԪӼвԸ
void			test_set_test_mode(int mode);												//òģʽ
void			test_set_unit(int unit);													//СԵԪ
void			test_setup_menu_index(void);												//
void			test_show_menu(void);														//ʾǰ˵

#endif
