#include <stdio.h>
#include <string.h>
#include <test/test_func.h>

#define	MAX_COUNT_LIB_EXAMPLE		50

static test_item_s				test_file[MAX_COUNT_LIB_EXAMPLE];
static int						file_count = 0;

extern void		file_example_1_init(test_item_s* parent);
extern void		file_example_2_init(test_item_s* parent);

static void lib_add_file(const char* name, test_init_f init, const char* menu_name)
{
	if(file_count >= MAX_COUNT_LIB_EXAMPLE)
	{
		printf("Can't add more file!\n");
		return;
	}

	test_init_file(test_file + file_count, name, test_do_nothing, menu_name, NULL);
	init(test_file + file_count);
	file_count++;
}

void lib_example_init(test_item_s* parent)
{
	memset(test_file, 0, sizeof(test_item_s) * MAX_COUNT_LIB_EXAMPLE);

	lib_add_file("file_example_1", file_example_1_init, NULL);
	lib_add_file("file_example_2", file_example_2_init, NULL);

	if(parent)
	{
		test_add_sub_item(parent, test_file, file_count);
	}
}
