#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <test/test_func.h>

#include "../cmd/cmd.h"


#define	MAX_CNT_LIB			10

static test_item_s		test_lib[MAX_CNT_LIB];
static int				lib_cnt;

extern void			lib_example_init(test_item_s* parent);

static void add_lib(const char* name, test_init_f init, const char* menu_name)
{
	if(lib_cnt >= MAX_CNT_LIB)
	{
		printf("Can't add more lib!\n");
		return;
	}

	test_init_lib(test_lib + lib_cnt, name, test_do_nothing, NULL, NULL);
	init(test_lib + lib_cnt);
	lib_cnt++;
}

static void all_lib_init(test_item_s* parent)
{
	memset(test_lib, 0, sizeof(test_item_s) * MAX_CNT_LIB);

	add_lib("lib_example", lib_example_init, NULL);

	if(parent)
	{
		test_add_sub_item(parent, test_lib, lib_cnt);
	}
}

int main(void)
{
	test_item_s* top_item;

	top_item = test_get_top_item();
	all_lib_init(top_item);
	test_setup_menu_index();

	printf("\n******************************************************\n");
	printf("Hello! This test codes tool is modified by xuanlin, at 2011-09-01!\n");
	printf("\t-Let's go!-\n");
	printf("*******************************************************\n");
	test_show_menu();

	cmd_main_loop();

	return 0;
}
